Rem --- eWON start section: Cyclic Section
eWON_cyclic_section:
Rem --- eWON user (start)
Clock:
A$ = Time$
H% = Val(A$(12 To 13))
M% = Val(A$(15 To 16))
D% = Val(A$(1 To 2))
Z% = Val(A$(4 To 5))
Y% = Val(A$(7 To 10))
Viewon_Time@ = A$
PRINT Viewon_Time@ 
END
Rem --- eWON user (end)
End
Rem --- eWON end section: Cyclic Section
Rem --- eWON start section: Init Section
eWON_init_section:
Rem --- eWON user (start)
REM Gosub Set_Leachate_Tank_Level_Flag

PRINT "Heartbeat Timer starting"
ONTIMER 1,"goto SetMLT"
REM TSET 1,900
TSET 1,10
ONTIMER 2,"goto ClearMLT"
TSET 2,0
REM Gosub SnFInit
REM REM Gosub SetLeachate_Tank_Level_High_Flag
REM Goto "SetLeachate_Tank_Level_High_Flag"
END
REM Gosub SetLeachate_Tank_Level_High_Flag
SetMLT:
PRINT "Setting Watchdog to 1"
WDOG_AL@ = 1
REM PRINT "Setting MLT Alarm"
TSET 1,10
REM TSET 2,60
TSET 2,5
REM Goto "SetLeachate_Tank_Level_High_Flag"
END
REM Gosub Set_Leachate_Tank_Level_Flag
ClearMLT:
Print "Setting Watchdog to 0"
WDOG_AL@ = 0
REM PRINT "Clearing MLT Alarm"
REM Print TSET 1,900
TSET 1,10
TSET 2,0
REM Goto "SetLeachate_Tank_Level_High_Flag"
REM REM Gosub SetLeachate_Tank_Level_High_Flag
END

REM Gosub Set_Leachate_Tank_Level_Flag
REM Goto SetMLT
REM PRINT "Setting Leachate_Tank_Level_High_Flag on/off value"
REM r% = "Leachate_Tank_Level"
REM ONALARM  "Leachate_Tank_Level","goto Leachate_Alarm_OnorOFF"

REM Set_Leachate_Tank_Level_Flag:
r% = ALSTAT "Leachate_Tank_Level"
IF (r% = 2) THEN
  Leachate_Tank_Level_High_Flag@ = 1
  PRINT "Leachate Tank Hi Level Alarm"
 ENDIF
IF (r% = 0) THEN
  Leachate_Tank_Level_High_Flag@ = 0
  PRINT "Leachate Tank Normal Level"
 ENDIF
RETURN


 REM e$ = "LOG_TRIGGER"
 REM ExistsTest = LOG_TRIGGER@
 REM LOG_TRIGGER@ = 0 :REM Reset Log Trigger
REM ONCHANGE "Elec1Pulse","IF (Elec1Pulse@<>0)THEN Elec1EnergyTotal@=Elec1EnergyTotal@+1"
REM ONCHANGE "Elec2Pulse","IF (Elec2Pulse@<>0)THEN Elec2EnergyTotal@=Elec2EnergyTotal@+1"
REM ONCHANGE "Water1Pulse","IF (Water1Pulse@<>0)THEN Water1EnergyTotal@=Water1EnergyTotal@+1"

REM ************************ eWON Store'n Forward *************************************
REM  MAC Solutions UK Ltd
REM  Author: Audrius Asadauskas
REM  Version: 1.0
REM  Modified by Alexandre Jin
REM  Deleted sections to keep logging on schedule only
REM ***********************************************************************************
SnFInit:
 LOGEVENT "Store'n Forward is initializing", 199
 PRINT TIME$ + " - Store'n Forward is initializing"
 REM Bind to Log Trigger tag's event to start data logging
 e$ = "LOG_TRIGGER"
 ExistsTest = LOG_TRIGGER@
 LOG_TRIGGER@ = 0 :REM Reset Log Trigger
 ONCHANGE e$, "GOTO LogData"
 REM Get Log Schedule value to associate it with Task Planner schedule
 e$ = "LOG_SCHEDULE"
 e% = LOG_SCHEDULE@
 IF (e% > 0 AND e% <= 10) THEN
  SETSYS SYS,"load"
  a$ = GETSYS SYS,"PlannerEntry" + STR$(e%) :REM Get Planner settings
  a% = INSTR 1, a$, "TimeDesc:" :REM Find starting position for Time Interval
  b% = INSTR a%, a$, CHR$(13) :REM Find end position for Time Interval
  
  REM If the last item
  IF (b% = 0) THEN 
   a$ = a$(a% + 9 To) :REM Get Time Interval
  ELSE
   a$ = a$(a% + 9 To b%) :REM Get Time Interval
  ENDIF
  ONDATE e%, a$, "LOG_TRIGGER@ = 1" :REM On the schedule trigger data logging
  
  LOGEVENT "Data logging on schedule Entry" + STR$(e%) + ": " + a$, 199
  PRINT TIME$ + " - Data logging on schedule Entry" + STR$(e%) + ": " + a$
 ELSE
  LOGEVENT "No schedule selected for Data Logging", 199
  PRINT TIME$ + " - No schedule selected for Data Logging"
 ENDIF
 
SnFInitError:
 i%=GETSYS PRG,"EVTINFO"
 IF (i% = 4 OR i% = 16) THEN
  LOGEVENT "Store'n Forward initialization failed: Tag with name " + e$ + " does not exist", 99
 ELSE
  LOGEVENT "Store'n Forward initialization failed: See Script Control page for more details", 99
 ENDIF
END
LogData:
 IF LOG_TRIGGER@ THEN
  LOGEVENT "Logging data started", 199
  PRINT TIME$ + " - Logging data started"
  REM Loop through all tags by their index and trigger logging operation
  ONERROR "GOTO NoMoreTags" :Rem if error occurs it means 
  secs% = Getsys Prg,"TIMESEC"
  fileName$ = "/logging/VES_Norwood-" + STR$(secs%) + ".csv"
  FS "mkdir", "/usr/logging"
  OPEN fileName$ FOR BINARY OUTPUT AS 1
  PUT 1, "Timestamp,MeterCode,Value" + CHR$ 13 + CHR$ 10
  FOR i% = 0 To -21 Step -1
   SETSYS TAG, "load", i%
   tagName$ = GETSYS TAG, "Name"
   tagValue = GETIO i%
   tagValueS$ = STR$ tagValue
   tagIndex$ = STR$(i%)
   PUT 1, TIME$; ","; tagName$; ","; tagValueS$ + CHR$ 13 + CHR$ 10
   PRINT tagIndex$ + " - " + tagName$ + " - Logging"
   LOGIO tagName$
  NEXT i%
  NoMoreTags:
  CLOSE 1
  
  ONERROR "GOTO Done" :Rem if error occurs it means 
  
  PRINT TIME$ + " - Logging data completed"
  LOGEVENT "Logging data completed", 199
  
  PRINT TIME$ + " - FTP upload starting"
  LOGEVENT "FTP upload starting", 199
  
  numFiles% = FS "count", "/usr/logging"
  PRINT STR$(numFiles%) + " files to upload."
  
  OPEN "/temp.txt" FOR TEXT OUTPUT AS 4
    FOR i% = 0 To (numFiles% - 1) Step 1
      fileName$ = FS "ls", "/usr/logging", i%   
      PRINT "Got fileName " + fileName$   
      PUT 4, fileName$    
    NEXT i%
  CLOSE 4
  
  OPEN "/temp.txt" FOR TEXT INPUT AS 4
    ReadNext:
    IF EOF 4 THEN GOTO ReadDone
    
      fileName$ = GET 4
    
      OPEN "/logging/" + fileName$ FOR BINARY INPUT AS 1   
        content$ = GET 1, 50000 
        PRINT "Uploading file: " + fileName$    
        PUTFTP fileName$, content$    
      CLOSE 1
      
      actionid% = GETSYS PRG, "ACTIONID"
      PRINT "Waiting for Result"
      WAIT_FOR_RESULT:  
      actionStat% = GETSYS PRG, "ACTIONSTAT"
      IF actionStat% = -1 THEN
        GOTO WAIT_FOR_RESULT
      ENDIF
    
      PRINT "Got Result " + STR$(actionStat%)
    
      IF actionStat% = 0 THEN
        PRINT "Deleting File"
        FS "rm", "/usr/logging/" + fileName$
        PRINT "File Deleted"
      ENDIF
     
    GOTO ReadNext      
    ReadDone:
  
 Done:
   CLOSE 4
 LOG_TRIGGER@ = 0 :Rem as logging is complete reset the LogTrigger flag
 ENDIF
End

REM Initialize Store'n Forward 
GOSUB SnFInit
Rem --- eWON user (end)
End
Rem --- eWON end section: Init Section
